/**
 * An error that is thrown when the neighbor does not exist in the grid
 */
export class NeighborDoesNotExistInGridError extends Error {
    type = NeighborDoesNotExistInGridError.name;
    /**
     * @param grid The grid
     * @param coordinate The coordinate of the source cell
     * @param direction The direction to the not existing neighbor
     */
    constructor(grid, coordinate, direction) {
        const { width, height } = grid;
        const { row, col } = coordinate;
        super(`Cell [row: ${row}, col: ${col}] has no ${direction} neighbor in grid [width: ${width}, height: ${height}]`);
    }
}
