/**
 * A straight direction
 */
export type StraightDirection = 'TOP' | 'BOTTOM' | 'LEFT' | 'RIGHT';
/**
 * A diagonal direction
 */
export type DiagonalDirection = 'TOP_LEFT' | 'TOP_RIGHT' | 'BOTTOM_LEFT' | 'BOTTOM_RIGHT';
/**
 * A straight or diagonal direction
 */
export type Direction = StraightDirection | DiagonalDirection;
/**
 * An array of all straight directions
 */
export declare const STRAIGHT_DIRECTIONS: StraightDirection[];
/**
 * An array of all diagonal directions
 */
export declare const DIAGONAL_DIRECTIONS: DiagonalDirection[];
/**
 * An array of all straight and diagonal directions
 */
export declare const ALL_DIRECTIONS: Direction[];
//# sourceMappingURL=Direction.d.ts.map